=== debian/rules ===
#!/usr/bin/make -f

TGT=$(CURDIR)/debian/apt-cacher-ng
CDIR=$(TGT)/etc/apt-cacher-ng

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
# cmake doesn't respect CPPFLAGS, use the workaround as suggested in
# https://wiki.debian.org/Hardening#Notes_for_packages_using_CMake
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --parallel

override_dh_auto_build:
	dh_auto_build -- VERBOSE=1

override_dh_install:
	dh_install $(shell test -e build/acngfs || echo -Xacngfs)
	grep -q "define.*HAVE_SD_NOTIFY" build/acsyscap.h && sed -e s,^Type=simple,Type=notify, systemd/apt-cacher-ng.service > debian/apt-cacher-ng.service || cp systemd/apt-cacher-ng.service debian/apt-cacher-ng.service
	cp systemd/apt-cacher-ng.conf debian/apt-cacher-ng.tmpfile
	install -m 755 scripts/expire-caller.pl $(TGT)/usr/lib/apt-cacher-ng
	$(MAKE) -C dbgen package DBGENERATOR=dbgenerator

override_dh_installinit:
	dh_installinit -- defaults 18

override_dh_compress:
	dh_compress -X.pdf

override_dh_clean:
	dh_clean
	rm -rf debian/apt-cacher-ng.service debian/apt-cacher-ng.tmpfile dbgen/dbgenerator.* dbgen/dbupdate
	debconf-updatepo

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog
