=== debian/changelog ===
apt-cacher-ng (0.8.3-1~bpo80+2) jessie-backports; urgency=low

  * Rebuilt with binary-arch packages

 -- Eduard Bloch <blade@debian.org>  Tue, 12 May 2015 20:07:28 +0200

apt-cacher-ng (0.8.3-1~bpo80+1) jessie-backports; urgency=low

  * Jessie backport from current Testing

 -- Eduard Bloch <blade@debian.org>  Fri, 08 May 2015 18:59:05 +0200

apt-cacher-ng (0.8.3-1) unstable; urgency=medium

  * New upstream version
    + solves the expiration hickup with disappeared .bz2 file versions

 -- Eduard Bloch <blade@debian.org>  Sat, 02 May 2015 17:20:16 +0200

apt-cacher-ng (0.8.2-1) unstable; urgency=low

  * New upstream version
    + forwarding of bugs.debian.org SOAP traffic through proxy cascades
      and potential bugfixes of its transport code (closes: #775126)
    + includes httpredir.debian.org in the mirror list (closes: #782643)
    + adds routing of HTTPS traffic through proxy cascades (closes: #734581)
    + improves HTTPS tunnel config documentation (closes: #779175)
    + adds documentation and example on how to track SIGBUS restarts to the
      (probably damaged) last open files (closes: #773825)

  [ Felix Geyer ]
  * added quiet option to systemctl calls to make logrotate less noisy
    (closes: #782562)

 -- Eduard Bloch <blade@debian.org>  Wed, 29 Apr 2015 11:31:38 +0200

apt-cacher-ng (0.8.1-1~bpo70+1) wheezy-backports; urgency=low

  * Minor version update

 -- Eduard Bloch <blade@debian.org>  Fri, 13 Feb 2015 16:48:46 +0100

apt-cacher-ng (0.8.1-1) unstable; urgency=low

  * New upstream version
    + transition to libsystemd without -daemon where possible (closes: #779739)
    + LTO disabled by default
    + *.o file download as volatile type (LP: #1078224)
    + more Fedora mirrors (Carlos Maddela, closes: #780555)
    + corrects handling of SPfilePatternEx (Carlos Maddela, closes: #780550)
  * Debconf question to enable HTTP tunnels, e.g. for https (closes: #734581)
  * Debconf translation updates: German (Holger Wansing, closes: #781921),
    French (Jean-Baka Domelevo Entfellner, closes: #782026), Italian (Beatrice
    Torracca, closes: #782013), Dutch (Frans Spiesschaert), Polish (Łukasz
    <BartekChom@poczta.onet.pl>), Swedish (Martin Bagge, Anders Jonsson,
    closes: #781672), Czech (Miroslav Kure, closes: #781447), Russian (Yuri
    Kozlov, closes: #781364), Danish (Joe Dalton, closes: #781328)

 -- Eduard Bloch <blade@debian.org>  Fri, 10 Apr 2015 23:40:20 +0200

apt-cacher-ng (0.8.0-3~bpo70+2) wheezy-backports; urgency=low

  * Making sure to really use g++-4.7 on all architectures

 -- Eduard Bloch <blade@debian.org>  Fri, 13 Feb 2015 16:48:46 +0100
